<?php
/*
 * http://maxsite.org/page/php-modules
*/
 
// set dirs
define('MODULES_DIR',  __DIR__ . '/modules/');
define('DISTR_DIR',    __DIR__ . '/distr/');
define('COMPOSER_DIR', __DIR__ . '/vendor/');
 
// autoload composer
if (file_exists(COMPOSER_DIR . 'autoload.php')) require COMPOSER_DIR . 'autoload.php'; 
 
// autoload distr (non psr-4)
if (file_exists(DISTR_DIR . 'autoload.php')) require DISTR_DIR . 'autoload.php'; 
 
// register autoload classes PSR-4
spl_autoload_register(function($class) {
	$a = explode('\\', $class);
	$fn = $class . '/' . array_pop($a) . '.php';
	$fn = str_replace('\\', '/', $fn);
	
	if (file_exists(MODULES_DIR . $fn)) require MODULES_DIR . $fn;
	else if (file_exists(DISTR_DIR . $fn)) require DISTR_DIR . $fn;	
});
 
// MY APPLICATION SAMPLE
 
// modules
$o1 = new Module1('Module1');
 
// submodule
$o2 = new Module1\SubModule1('SubModule1');
 
// distr/Project1
$o3 = new Project1('distr/Project1');
 
// module use distr/Project1
$o4 = new Module1\MProject1('MProject1 use Project1');
 
// composer Parsedown
$Parsedown = new Parsedown();
echo $Parsedown->text('Hello _Parsedown_!');

// module use composer Parsedown
$o5 = new Module1\MParsedown('This is **MParsedown**!');

# end of file